<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 23B</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <style>
        .picture-cover {
            background-image: url("cover.jpg");
            min-height: 100px;
            margin: 5px;

        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5    ">
                <div class="row   form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group">
                    <div class="col-4  ">
                        <label>User Name</label>
                    </div>
                    <div class="col-8  ">
                        <input id="input-user" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <div class="col-4  ">
                        <label>First Name </label>
                    </div>
                    <div class="col-8  ">
                        <input id="input-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group">
                    <div class="col-4  ">
                        <label>Last Name</label>
                    </div>
                    <div class="col-8  ">
                        <input id="input-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center">
                <div class="row form-group">
                    <div class="col-12  ">
                        <button id="btn-dice" class="btn btn-success button-width w-75" value="Ném"
                            onclick="onBtnClickDice()" type="button">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <img id="img-dice" src="dice.png" class="img-thumbnail">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <p id="p-notification-dice">Chúc Mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center">
                <div class="row form-group">
                    <div class="col-12  ">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12  ">
                        <img id="img-present" class="img-thumbnail" src="xe-may.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group">
            <div class="col-12">
                <button onclick="onBtnDiceHistory()" id="btn-dice-history" class="btn btn-info button-width w-25">Dice
                    Button</button>
                <button id="btn-voucher-histore" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row ">
            <div class="col-12">
                <table id="history-placehoder-table" class="table table-striped table-hover ">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

</body>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    // Vùng Global
    function onBtnClickDice() {
        var vDice =
        {
            userName: "",
            firstName: "",
            lastName: "",
        };
        thuThapDuLieu(vDice);
        var vDuLieuHopLe = validateDice(vDice);
        if (vDuLieuHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            callAPIDice(vDice, vXmlHttpDice);
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    //hãy REFACTORING ĐẨY MÃ NGUỒN XỬ LÝ RA FUNCTION KHÁC
                    console.log(vXmlHttpDice.responseText);
                    showDataDice(vXmlHttpDice);
                }
            }
        }
    }
    // Nút sự kiện Dice history
    function onBtnDiceHistory() {
        var vUserDiceHistory =
        {
            userName: "",
        };
        thuThapDuLieuDiceHistory(vUserDiceHistory);
        var vXmlHttpDiceHistory = new XMLHttpRequest();
        callAPIDiceHistory(vUserDiceHistory, vXmlHttpDiceHistory);
        vXmlHttpDiceHistory.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttpDiceHistory.responseText);
                showDataDiceHistory(vXmlHttpDiceHistory);
            }
        }
    }

    // Vùng sự kiện cho Dice
    function thuThapDuLieu(paramUser) {
        var vInputUserName = document.getElementById("input-user");
        var vInputFirstName = document.getElementById("input-first-name");
        var vInputLastName = document.getElementById("input-last-name");
        //
        paramUser.userName = vInputUserName.value.trim();
        paramUser.firstName = vInputFirstName.value.trim();
        paramUser.lastName = vInputLastName.value.trim();
    }
    // thu thập dữ liệu Dice history 
    function thuThapDuLieuDiceHistory(paramUser) {
        var vInputUserName = document.getElementById("input-user");
        paramUser.userName = vInputUserName.value.trim();
    }
    //
    function validateDice(paramUser) {
        if (paramUser.userName == "") {
            alert("Bạn chưa nhập thông tin");
            return false;
        }
        if (paramUser.firstName == "") {
            alert("Bạn chưa nhập thông tin");
            return false;
        }
        if (paramUser.lastName == "") {
            alert("Bạn chưa nhập thông tin");
            return false;
        }
        return true;
    }
    //
    function callAPIDice(paramUser, paramXmlHttp) {
        paramXmlHttp.open("POST", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUser));
    }
    //
    function showDataDice(paramXmlHttp) {
        console.log(paramXmlHttp.responseText);
        // chuyện string về JSON obj sau khi thêm từ sever
        var vResponseObj = JSON.parse(paramXmlHttp.responseText);
        console.log(vResponseObj);
        // lấy giá trị dice từ JSON
        var vDiceClick = vResponseObj.dice;
        console.log("Dice : " + vDiceClick);
        // thay đổi hình ảnh khi ném xí ngầu
        changeDice(vDiceClick);
        // thay đổi lời chúc mừng
        changeNotification(vDiceClick);
        // gọi hàm hiện thị voucher
        callAPIVoucher(vResponseObj);
        // gọi hàm hiện thị quà tặng 
        changeGift(vResponseObj);

    }
    // event Img cho Dice 
    function changeDice(paramDice) {
        var vInputImgDice = document.getElementById("img-dice");
        switch (paramDice) {
            case 1:
                vInputImgDice.src = "1.png";
                break;
            case 2:
                vInputImgDice.src = "2.png";
                break;
            case 3:
                vInputImgDice.src = "3.png";
                break;
            case 4:
                vInputImgDice.src = "4.png";
                break;
            case 5:
                vInputImgDice.src = "5.png";
                break;
            case 6:
                vInputImgDice.src = "6.png";
                break;
            default:
                vInputImgDice.src = "7.png";
        }
    }
    //
    function changeNotification(paramDice) {
        var vNotification = document.getElementById("p-notification-dice");
        if (paramDice < 4) {
            vNotification.innerHTML = ("Chúc mừng bạn may mắn lần sau");
        }
        else {
            vNotification.innerHTML = ("Chúc mừng bạn hãy chơi tiếp lần nữa");
        }
    }
    //
    function callAPIVoucher(paramXmlHttp) {
        var vPVoucherId = document.getElementById("p-voucher-id");
        var vPVoucherPreCent = document.getElementById("p-voucher-percent");
        if (paramXmlHttp.voucher != null) {
            vPVoucherId.innerHTML = paramXmlHttp.voucher.maVoucher;
            vPVoucherPreCent.innerHTML = paramXmlHttp.voucher.phanTramGiamGia + "%";
        }
        else {
            vPVoucherId.innerHTML = "";
            vPVoucherPreCent.innerHTML = "";
        }
    }
    //
    function changeGift(paramDice) {
        var vImgPreCent = document.getElementById("img-present");
        var vTenQua = paramDice.prize;
        switch (vTenQua) {
            case "Mũ":
                vImgPreCent.src = "hat.jpg";
                break;
            case "Áo mưa":
                vImgPreCent.src = "ao-mua.jpg";
                break;
            case "Ô tô":
                vImgPreCent.src = "car.jpg";
                break;
            case "Xe máy":
                vImgPreCent.src = "xe-may.jpg";
                break;
            case "Sổ":
                vImgPreCent.src = "book.jpg";
                break;
            default:
                vImgPreCent.src = "no-present.jpg";
        }
    }
    // Vùng event cho nút dice history 
    function callAPIDiceHistory(paramDice, paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramDice.userName, true);
        paramXmlHttp.send();
        console.log(paramDice.userName);
    }
    //
    function showDataDiceHistory(paramXmlHttp) {
        var vPersonDiceHistory = JSON.parse(paramXmlHttp.responseText);
        console.log(vPersonDiceHistory);
        var vTable = document.getElementById("history-placehoder-table");
        var vTbody = document.getElementsByTagName("tbody")[0];
        for (var bI = 0; bI < vPersonDiceHistory.dices.length; bI++) {
            var bRowThead = vTbody.insertRow(-1);
            var bCellLuotChoi = bRowThead.insertCell(0);
            var bCellDice = bRowThead.insertCell(1);

            //
            bCellLuotChoi.innerHTML = bI + 1;
            bCellDice.innerHTML = vPersonDiceHistory.dices[bI];
        }
    }

</script>

</html>